! ----------------------------------------------------------------------------------
!   IO.h 
!   di Vincenzo Scarpa
!   luglio-agosto 2005
!
!   Raccolta di funzioni per il trattamento dell'input e dell'output dei dati 
!   numerici e delle stringhe.
! ----------------------------------------------------------------------------------



! ----------------------------------------------------------------------------------
!   CmpStr 
!   Questa funzione compara due stringhe restituendo 1 se sono uguali, viceversa 0.
! ----------------------------------------------------------------------------------
[ CmpStr temp1 temp2 i c;
  #IfDef TARGET_ZCODE;
  i=2; c=0;
  
  !se le stringhe non hanno la stessa lunghezza
  if (temp1->1 ~= temp2->1) return 0;
  
  .Compare;
  if(temp1->i == temp2->i) {i++; c++;} else return 0;
  if(c==temp2->1) return 1; else jump Compare;
  #IfNot;
  i=4; c=0; 
  
  !se le stringhe non hanno la stessa lunghezza
  if (temp1->3 ~= temp2->3) return 0;
  
  .Compare;
  if(temp1->i == temp2->i) {i++; c++;} else return 0;
  if (c==temp2->3) return 1; else jump Compare;
  #Endif;
];



! ----------------------------------------------------------------------------------
!   GetNumber
!   Questa funzione legge un valore numerico:
!   - per Inform (MAX 5 cifre - da 0 a 32767)
!   - per Glulx (MAX 5 cifre - da 0 a 99999)
! ----------------------------------------------------------------------------------
Array Ginput1->10;
Array Ginput2->10;

[ GetNumber n k;
    if (n>5) n=5;
    if (n<1) n=1;
    for (k=0: k<10: k++) Ginput1->k=0; 
    Ginput1->0=n;
    KeyboardPrimitive(Ginput1, Ginput2);

    #IfDef TARGET_ZCODE;
    if (Ginput1->2<48 || Ginput1->2>57) rfalse; ! se non  stato inserito un numero esce
    if (Ginput1->3<48 || Ginput1->3>57)
        return Ginput1->2-48;
    if (Ginput1->4<48 || Ginput1->4>57) 
        return ((Ginput1->2-48)*10) + (Ginput1->3-48); 
    if (Ginput1->5<48 || Ginput1->5>57)
        return ((Ginput1->2-48)*100) + ((Ginput1->3-48)*10) + (Ginput1->4-48); 
    if (Ginput1->6<48 || Ginput1->6>57)
        return ((Ginput1->2-48)*1000) + ((Ginput1->3-48)*100) + ((Ginput1->4-48)*10) + (Ginput1->5-48); 
    if ((Ginput1->2>51) || (Ginput1->3>50) || (Ginput1->4>55) || (Ginput1->5>54) || (Ginput1->6>55)) 
       rfalse; !se  stato inserito un numero maggiore di 32767 
    return ((Ginput1->2-48)*10000) + ((Ginput1->3-48)*1000) + ((Ginput1->4-48)*100) + ((Ginput1->5-48)*10) + (Ginput1->6-48);
    #IfNot;
    if (Ginput1->4<48 || Ginput1->4>57) rfalse; ! se non  stato inserito un numero esce
    if (Ginput1->5<48 || Ginput1->5>57)
        return Ginput1->4-48;
    if (Ginput1->6<48 || Ginput1->6>57) 
        return ((Ginput1->4-48)*10) + (Ginput1->5-48); 
    if (Ginput1->7<48 || Ginput1->7>57)
        return ((Ginput1->4-48)*100) + ((Ginput1->5-48)*10) + (Ginput1->6-48); 
    if (Ginput1->8<48 || Ginput1->8>57)
        return ((Ginput1->4-48)*1000) + ((Ginput1->5-48)*100) + ((Ginput1->6-48)*10) + (Ginput1->7-48); 
    return ((Ginput1->4-48)*10000) + ((Ginput1->5-48)*1000) + ((Ginput1->6-48)*100) + ((Ginput1->7-48)*10) + (Ginput1->8-48);
    #EndIf;
];



! ----------------------------------------------------------------------------------
!   Presskey
!   Questa funzione legge il carattere di un tasto premuto dall'utente senza la 
!   pressione del tasto di Invio. 
! ----------------------------------------------------------------------------------
[ Presskey car;
    car = KeyCharPrimitive();
    return car;
]; 



! ----------------------------------------------------------------------------------
!   PrintNumericArray
!   Questa funzione stampa a video il contenuto di un vettore numerico.
! ----------------------------------------------------------------------------------
[ PrintNumericArray the_array len i;
  for (i=0: i<len: i++) print the_array->i, " ";
];



! ----------------------------------------------------------------------------------
!   PrintStringArray
!   Questa funzione stampa un array di tipo stringa. Prima di chiamarla, 
!   caricate l'array con l'istruzione PrintToBuffer(array, lunghezza, stringa);
!   Le dimensioni dell'array devono essere calcolate in base alla lunghezza
!   massima del testo che pu contenere (+ 3 per Inform e +5 per Glulx) --> es: 
!   se l'array deve contenere un testo lungo al massimo 20 caratteri, dovr essere 
!   definito nel modo seguente: Array nome_array->23; per Inform e 
!   Array nome_array->25; per Glulx. 
!   Per utilizzarla, occorre dichiarare la costante PRINT_STRING_ARRAY.
! ----------------------------------------------------------------------------------
[ PrintStringArray the_array i;
  #IfDef TARGET_ZCODE;
  for (i=2: i<(the_array->1)+2: i++) print (char) the_array->i;
  #IfNot;
  for (i=4: i<=(the_array->3)+3: i++) print (char) the_array->i;
  #EndIf;
];



! ----------------------------------------------------------------------------------
!   ReadArray
!   Questa funzione legge un carattere, una parola o una stringa inserita 
!   dall'utente. Occorre passarle l'array ne quale memorizzare la stringa 
!   e la sua lunghezza massima, tenendo sempre conto del +3 sotto Inform e
!   del +5 sotto Glulx. 
! ----------------------------------------------------------------------------------
Array readarr->8;

[ ReadArray the_array lungh i;
  the_array->0=lungh-3;
  
  i=0;
  do
  {
     i++;
     if (i<=lungh) KeyboardPrimitive(the_array, readarr);
     else break;
  }
  until (i <= lungh);
];



! ----------------------------------------------------------------------------------
!   Readchar
!   Questa funzione legge un carattere digitato dalla tastiera con la pressione
!   del tasto di Invio. 
! ----------------------------------------------------------------------------------
Array Rtext1->5;
Array Rtext2->5;

[ Readchar;
  Rtext1->0=1;
  KeyboardPrimitive(Rtext1, Rtext2);
  
  #IfDef TARGET_ZCODE;
  return Rtext1->2;
  #IfNot;
  return Rtext1->4;
  #EndIf;
];

! ----------------------------------------------------------------------------------
!   Questa funzione elimina i warning in fase di compilazione
!   (su suggerimento di Paolo Lucchesi).
! ----------------------------------------------------------------------------------
[ io_h_warning_squasher;
   GetNumber();
   Presskey();
   Readchar();
   ReadArray();
   PrintStringArray();
   PrintNumericArray();
   cmpstr();
   io_h_warning_squasher();
];



